=== debian/changelog ===
yosys (0.9-1build2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 11:21:47 +0000

yosys (0.9-1build1) focal; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 12 Jan 2020 08:30:38 +0000

yosys (0.9-1) unstable; urgency=medium

  * Upload to sid
  * New upstream release
    - Refreshed patches
  * debian/copyright:
    - Get copyright info up-to-date
  * debian/control:
    - New standards version 4.4.0 - no changes
    - DH level 12
    - Use debhelper-compat instead of debian/compat file
    - Change build-dependency from texlive-generic-recommended to
      texlive-plain-generic (Closes: #941555) (Thanks Steve Langasek)
  * debian/rules:
    - Don't override dh_install with --fail-missing anymore

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 18 Oct 2019 23:27:34 +0200
