=== debian/changelog ===
yosys (0.19-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * d/control: Bumped standard to 4.6.1
  * d/u/metadata: Added SciCrunch RRID:SCR_022549

  [ Daniel Gröber ]
  * New upstream version 0.19

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 30 Jul 2022 17:26:45 +0200

yosys (0.18-1) unstable; urgency=medium

  * New upstream version 0.18
  * Fix autopkgtest failure
  * Add salsa-ci config
  * Disable building for mips64el

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 18 Jun 2022 22:24:49 +0200

yosys (0.15-1) unstable; urgency=medium

  * New upstream version 0.15

 -- Daniel Gröber <dxld@darkboxed.org>  Sat, 26 Mar 2022 16:55:23 +0100

yosys (0.12-1) unstable; urgency=medium

  * Homepage and d/watch now pointing to github.com
  * New upstream version 0.12
  * Fix patches and packaging for new upstream release
      * Now overridden using make variables in debian/rules instead:
        01_gitrevision.patch
        02_removeabc.patch
        05_abc_executable.patch
        0013-Let-dpkg-buildpackage-handle-stripping-of-binaries.patch
      * Fixed upstream
        0015-Fix-gcc11-FTBFS.patch
        manual-build.patch
      * Deemed unnecessary
        0011-Do-not-show-g-build-flags-in-Version-string.patch
  * Add missing dependencies to yosys-dev
  * Raise debhelper-compat to 13
  * New standards version 4.6.0 - no changes
  * Added rules-requires-root: no
  * Bump berkley-abc version bound
  * Add patch to enable loading plugins from /usr/lib/yosys/plugins
  * Add myself to Uploaders

 -- Daniel Gröber <dxld@darkboxed.org>  Thu, 13 Jan 2022 13:34:52 +0100

yosys (0.9-2) unstable; urgency=medium

  * Team Upload.
  * d/p/0015-Fix-gcc11-FTBFS.patch: Include limits to
    fix GCC-11 FTBFS (Closes: #984414)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 15 Aug 2021 14:14:47 +0530
