=== debian/rules ===
--- 
+++ 
@@ -13,13 +13,17 @@
 PDF_DATE2  :=     $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%B %d, %Y")
 CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")
 
+MAKE_VARS := \
+        CONFIG=gcc \
+	GIT_REV=2156e20 \
+	ABCEXTERNAL="berkeley-abc" ABCPULL=0 \
+	STRIP=:
 
 %:
 	PREFIX=/usr dh $@ --with=python3
 
-
 override_dh_auto_clean:
-	dh_auto_clean
+	dh_auto_clean -- $(MAKE_VARS)
 	$(RM) debian/man/*.1
 	$(RM) Makefile.conf
 
@@ -27,7 +31,7 @@
 	make config-gcc
 
 override_dh_auto_install:
-	dh_auto_install
+	dh_auto_install -- $(MAKE_VARS)
 	chmod a-x debian/tmp/usr/share/yosys/achronix/speedster22i/cells*.v
 
 override_dh_installman:
@@ -38,8 +42,11 @@
 	dh_compress --exclude=.pdf
 
 override_dh_auto_build-arch:
-	dh_auto_build --parallel -- all
+	dh_auto_build -- $(MAKE_VARS) all
 
 override_dh_auto_build-indep:
 	sed -i 's/REPLACEWITHDATE/$(PDF_DATE2)/' manual/presentation.tex
-	PDF_DATE=$(PDF_DATE) dh_auto_build --parallel -- all manual
+	PDF_DATE=$(PDF_DATE) dh_auto_build -- $(MAKE_VARS) all manual
+
+override_dh_auto_test:
+	dh_auto_test -- $(MAKE_VARS)
