=== debian/watch ===
version=3
https://github.com/YosysHQ/yosys/releases /YosysHQ/yosys/archive/refs/tags/\w+-(\d\S+)\.tar\.(?:bz2|gz|xz)
